﻿<%
'///////////////////////////////////////////////////////////////////////////////
'//              Z-Blog
'// 作    者:    朱煊(zx.asd)
'// 版权所有:    RainbowSoft Studio
'// 技术支持:    rainbowsoft@163.com
'// 程序名称:    
'// 程序版本:    
'// 单元名称:    c_banip.asp
'// 开始时间:    2005.04.01
'// 最后修改:    
'// 备    注:    BanIP
'///////////////////////////////////////////////////////////////////////////////


Class TBanIP

	Public CLSID
	Public Name
	Public Interval
	Public Length

	Private IpList()
	Private TimeList()

	Private IpNow
	Private TimeNow


	Private Function ChangeTimeToInteger(dtmTime)
		ChangeTimeToInteger=Year(dtmTime)*12*30*24*60*60 + Month(dtmTime)*30*24*60*60 + Day(dtmTime)*24*60*60 + Hour(dtmTime)*60*60 + Minute(dtmTime)*60 + Second(dtmTime)
	End Function


	Public Function LoadList()

		Dim i

		Dim aryIpList
		Dim aryTimeList

		Application.Lock

		aryIpList=Application(CLSID & Name & "IpList")
		aryTimeList=Application(CLSID & Name & "TimeList")

		Application.UnLock

		ReDim Preserve IpList(Length)
		ReDim Preserve TimeList(Length)

		If IsArray(aryIpList) Then

			For i=0 to Length
				IpList(i)=aryIpList(i)
				TimeList(i)=aryTimeList(i)
			Next

		Else
		End If

		'Response.Write Join(IpList)
		'Response.Write Join(TimeList)

	End Function


	Public Function SaveList()

		Application.Lock

		Application(CLSID & Name & "IpList")=IpList
		Application(CLSID & Name & "TimeList")=TimeList

		Application.UnLock

	End Function


	Private Function ClearList()

		Dim i
		Dim j

		For i=0 To Length
			If TimeNow-TimeList(i)>Interval Then
				IpList(i)=Empty
				TimeList(i)=0
				j=i
			End If
		Next

		For i=j+1 To Length
			IpList(i-j-1)=IpList(i)
			TimeList(i-j-1)=TimeList(i)
			IpList(i)=Empty
			TimeList(i)=0
		Next

	End Function


	Public Function Check(strIP)

		Dim i

		IpNow=strIP
		TimeNow=ChangeTimeToInteger(Now())

		ClearList()

		For i=0 to Length
			If Not IsEmpty(IpList(i)) Then
				If IpList(i)=IpNow Then Check=False
				Exit Function
			End If
		Next

		For i=0 to Length
			If IsEmpty(IpList(i)) Then
				IpList(i)=IpNow
				TimeList(i)=TimeNow
				Check=True
				Exit Function
			End If
		Next

		For i=0 to Length-1
			IpList(i)=IpList(i+1)
			TimeList(i)=TimeList(i+1)
		Next
		IpList(Length)=IpNow
		TimeList(Length)=TimeNow
		Check=True

	End Function


	Private Sub Class_Initialize()

	End Sub


	Private Sub Class_Terminate()

	End Sub

End Class

%>